/// <reference types="node" />
import { Context, RunningScriptOptions } from 'vm';
/**
 * Turns sync JavaScript code into an JavaScript with async Functions.
 *
 * @param {String} code JavaScript string to convert
 * @param {Array} names Array of function names to add `yield` operators to
 * @return {String} Converted JavaScript string with async/await injected
 * @api public
 */
declare function degenerator(code: string, _names: degenerator.DegeneratorNames, { output }?: degenerator.DegeneratorOptions): string;
declare namespace degenerator {
    type DegeneratorName = string | RegExp;
    type DegeneratorNames = DegeneratorName[];
    interface DegeneratorOptions {
        output?: string;
    }
    type CompileOptions = DegeneratorOptions & RunningScriptOptions & {
        sandbox?: Context;
    };
    function compile<T>(code: string, returnName: string, names: DegeneratorNames, options?: CompileOptions): T;
}
export = degenerator;
